VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CFile"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Const FILE_BEGIN = 0
Private Const FILE_CURRENT = 1
Private Const FILE_END = 2
Private Const FILE_SHARE_READ = &H1
Private Const FILE_SHARE_WRITE = &H2
Private Const GENERIC_READ = &H80000000
Private Const GENERIC_WRITE = &H40000000
Private Const INVALID_HANDLE_VALUE = -1
Private Const CREATE_NEW = 1
Private Const CREATE_ALWAYS = 2
Private Const OPEN_EXISTING = 3
Private Const OPEN_ALWAYS = 4
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function CreateFileW Lib "kernel32" (ByVal lpFileName As Long, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, ByVal lpSecurityAttributes As Long, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
Private Declare Function GetFileSize Lib "kernel32" (ByVal hFile As Long, ByRef lpFileSizeHigh As Long) As Long
Private Declare Function ReadFile Lib "kernel32" (ByVal hFile As Long, ByVal lpBuffer As Long, ByVal nNumberOfBytesToRead As Long, lpNumberOfBytesRead As Long, ByVal lpOverlapped As Long) As Long
Private Declare Sub RtlMoveMemory Lib "kernel32" (ByVal pDestination As Long, ByVal pSource As Long, ByVal Length As Long)
Private Declare Function SetFilePointer Lib "kernel32" (ByVal hFile As Long, ByVal lDistanceToMove As Long, ByRef lpDistanceToMoveHigh As Long, ByVal dwMoveMethod As Long) As Long
Private Declare Function WriteFile Lib "kernel32" (ByVal hFile As Long, ByVal lpBuffer As Long, ByVal nNumberOfBytesToWrite As Long, lpNumberOfBytesWritten As Long, ByVal lpOverlapped As Long) As Long

Dim fn$, fHandle&

Public Sub CloseFile()
CloseHandle fHandle
End Sub

Public Sub Create(ByRef FileName As String, Optional ByVal Overwrite As Boolean = True)
fn = FileName
If Overwrite Then
    fHandle = CreateFileW(StrPtr(fn), GENERIC_READ Or GENERIC_WRITE, FILE_SHARE_READ, 0, CREATE_ALWAYS, 0, 0)
Else
    fHandle = CreateFileW(StrPtr(fn), GENERIC_READ Or GENERIC_WRITE, FILE_SHARE_READ, 0, CREATE_NEW, 0, 0)
End If
If fHandle = INVALID_HANDLE_VALUE Then Err.Raise LastErrorToVBError(Err.LastDllError)
End Sub

Public Function GetPointer() As Long
GetPointer = SetFilePointer(fHandle, 0, 0, FILE_CURRENT)
End Function

Public Sub OpenFile(ByRef FileName As String)
If fHandle <> INVALID_HANDLE_VALUE Then CloseFile
fn = FileName
fHandle = CreateFileW(StrPtr(fn), GENERIC_READ Or GENERIC_WRITE, FILE_SHARE_READ, 0, OPEN_EXISTING, 0, 0)
If fHandle = INVALID_HANDLE_VALUE Then Err.Raise LastErrorToVBError(Err.LastDllError)
End Sub

Public Function ReadAll() As Byte()
Dim f() As Byte, HighOff&, lBytesRead&, nSize&, CurrentPointer&
On Error GoTo Fail
nSize = GetFileSize(fHandle, HighOff)
CurrentPointer = GetPointer
If HighOff <> 0 Or nSize < 0 Then GoTo Fail ''' >2GiB
nSize = nSize - CurrentPointer
ReDim f(nSize - 1) As Byte
Call ReadFile(fHandle, VarPtr(f(0)), nSize, lBytesRead, 0)
If lBytesRead <> nSize Then GoTo Fail
ReadAll = f()
Exit Function
Fail:
Err.Raise LastErrorToVBError(Err.LastDllError)
End Function

Public Function ReadByte() As Byte
Dim a As Byte, lBytesRead&
Call ReadFile(fHandle, VarPtr(a), 1, lBytesRead, 0)
If lBytesRead <> 1 Then GoTo Fail
ReadByte = a
Exit Function
Fail:
Err.Raise LastErrorToVBError(Err.LastDllError)
End Function

Public Function ReadLong() As Long
Dim a As Long, lBytesRead&
Call ReadFile(fHandle, VarPtr(a), 4, lBytesRead, 0)
If lBytesRead <> 4 Then GoTo Fail
ReadLong = a
Exit Function
Fail:
Err.Raise LastErrorToVBError(Err.LastDllError)
End Function

Public Function ReadCString() As Byte()
Dim a As Byte, f() As Byte, lBytesRead&, Size&, off&, off2&
off = GetPointer
Do
    Call ReadFile(fHandle, VarPtr(a), 1, lBytesRead, 0)
Loop While a <> 0 And lBytesRead = 1
If lBytesRead = 0 Then  ' ļβ
    off2 = GetPointer
Else
    off2 = GetPointer - 1
End If
SetPointer off
Size = off2 - off
ReDim f(Size - 1) As Byte
Call ReadFile(fHandle, VarPtr(f(0)), Size, lBytesRead, 0)
If lBytesRead <> Size Then GoTo Fail
ReadCString = f()
Exit Function
Fail:
Err.Raise LastErrorToVBError(Err.LastDllError)
End Function

Public Function Read(ByVal Size As Long) As Byte()
Dim f() As Byte, lBytesRead&
On Error GoTo Fail
ReDim f(Size - 1) As Byte
Call ReadFile(fHandle, VarPtr(f(0)), Size, lBytesRead, 0)
If lBytesRead <> Size Then GoTo Fail
Read = f()
Exit Function
Fail:
Err.Raise LastErrorToVBError(Err.LastDllError)
End Function

Public Sub ReadPtr(ByVal Ptr As Long, ByVal Size As Long)
Dim lBytesRead&
Call ReadFile(fHandle, Ptr, Size, lBytesRead, 0)
If lBytesRead <> Size Then GoTo Fail
Exit Sub
Fail:
Err.Raise LastErrorToVBError(Err.LastDllError)
End Sub

Public Function SetPointer(ByVal Pos As Long, Optional ByVal Mode As Long = FILE_BEGIN) As Long
Call SetFilePointer(fHandle, Pos, 0, Mode)
If Err.LastDllError Then Err.Raise LastErrorToVBError(Err.LastDllError)
End Function

Public Sub WriteByte(ByVal a As Byte)
Dim lBytesWritten&
Call WriteFile(fHandle, VarPtr(a), 1, lBytesWritten, 0)
If lBytesWritten <> 1 Then Err.Raise LastErrorToVBError(Err.LastDllError)
End Sub

Public Sub WriteLong(ByVal a As Long)
Dim lBytesWritten&
Call WriteFile(fHandle, VarPtr(a), 4, lBytesWritten, 0)
If lBytesWritten <> 4 Then Err.Raise LastErrorToVBError(Err.LastDllError)
End Sub

Public Sub WritePtr(ByVal Ptr As Long, ByVal Length As Long)
Dim lBytesWritten&
Call WriteFile(fHandle, Ptr, Length, lBytesWritten, 0)
If lBytesWritten <> Length Then Err.Raise LastErrorToVBError(Err.LastDllError)
End Sub

Private Sub Class_Initialize()
fHandle = INVALID_HANDLE_VALUE
End Sub

Private Sub Class_Terminate()
CloseFile
End Sub
