Attribute VB_Name = "mApp"
Option Explicit
Private Const OF_OPEN = 1
Private Const OF_SAVE = 2
Private Const OF_OPEN_MULTI = 3
Private Const OFN_ALLOWMULTISELECT = &H200
Private Const OFN_EXPLORER = &H80000
Private Const OFN_FILEMUSTEXIST = &H1000
Private Type OPENFILENAME
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    lpstrFilter As Long
    lpstrCustomFilter As Long
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As Long
    nMaxFile As Long
    lpstrFileTitle As Long
    nMaxFileTitle As Long
    lpstrInitialDir As Long
    lpstrTitle As Long
    Flags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As Long
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As Long
'#If (_WIN32_WINNT >= 0x0500)
    pvReserved As Long
    dwReserved As Long
    FlagsEx As Long
'#End If
End Type
Private Const MAX_PATH = 260
Private Declare Function CopyFileW Lib "kernel32" (ByVal lpExistingFileName As Long, ByVal lpNewFileName As Long, ByVal bFailIfExists As Long) As Long
Private Declare Function GetCommandLineW Lib "kernel32" () As Long
Private Declare Function GetModuleFileNameW Lib "kernel32" (ByVal hModule As Long, ByVal lpFileName As Long, ByVal nSize As Long) As Long
Private Declare Function GetOpenFileNameW Lib "comdlg32.dll" (ByRef pOpenfilename As OPENFILENAME) As Long
Private Declare Function GetSaveFileNameW Lib "comdlg32.dll" (ByRef pOpenfilename As OPENFILENAME) As Long
Private Declare Function MultiByteToWideChar Lib "kernel32" (ByVal CodePage As Long, ByVal dwFlags As Long, ByVal lpMultiByteStr As Long, ByVal cchMultiByte As Long, ByVal lpWideCharStr As Long, ByVal cchWideChar As Long) As Long
Private Declare Sub RtlMoveMemory Lib "kernel32" (ByVal pDest As Long, ByVal pSource As Long, ByVal numBytes As Long)
Private Declare Function lstrlenW Lib "kernel32" (ByVal lpStr As Long) As Long
Private ExeFileName As String
Private FullExePath As String
Private FullRunDir As String
Private ExeCommandLine As String
Private ExeCommandLineArgc As Long
Private ExeCommandLineArgv() As String
Private IsInIDE As Boolean

Public Property Get CommandLine() As String
CommandLine = ExeCommandLine
End Property

Public Property Get CommandArgc() As Long
CommandArgc = ExeCommandLineArgc
End Property

Public Property Get CommandArgv(Index As Long) As String
CommandArgv = ExeCommandLineArgv(Index)
End Property


Public Sub Initialize()
Dim ret As Long, a As Long, i As Long, CmLine As String
'ret = GetFullPathName(StrPtr("."), 0&, StrPtr(FullRunDir), 0&)
'FullRunDir = Space$(ret)
'ret = GetFullPathName(StrPtr("."), ret, StrPtr(FullRunDir), 0&)
'FullRunDir = Left$(FullRunDir, ret)
'If Right$(FullRunDir, 1) <> "\" Then FullRunDir = FullRunDir & "\"

FullExePath = Space$(1024)
ret = GetModuleFileNameW(0&, StrPtr(FullExePath), 1024&)
FullExePath = Trunc(FullExePath)
ExeFileName = Mid$(FullExePath, InStrRev(FullExePath, "\") + 1)
FullRunDir = Left$(FullExePath, InStrRev(FullExePath, "\"))
If LCase$(ExeFileName) = "vb6.exe" Then
    IsInIDE = True
    FullRunDir = App.Path
    If Right$(FullRunDir, 1) <> "\" Then FullRunDir = FullRunDir & "\"
    ExeFileName = App.EXEName & ".exe"
    FullExePath = FullRunDir & ExeFileName
    ExeCommandLine = Trim$(Command$)
    CmLine = """" & App.EXEName & """ " & Command$
Else
    IsInIDE = False
    CmLine = VBStrFromUnicodePtr(GetCommandLineW())
    ExeCommandLine = Trim$(CmLine)
    a = InStrChrOutQuote(1, ExeCommandLine, " ")
    If a <> 0 Then
        ExeCommandLine = Trim$(Mid$(ExeCommandLine, a + 1))
    Else
        ExeCommandLine = ""
    End If
End If
ExeCommandLineArgv = CommandLineToArgv(CmLine, ExeCommandLineArgc)

'mVer = GetVerInfo(FullExePath)
End Sub

Public Function LastErrorToVBError(ByVal LastErrorCode As Long) As Long
    Dim r As Long
    Select Case LastErrorCode
        Case 87
            r = 5
        Case 14
            r = 7
        Case 123
            r = 52
        Case 2
            r = 53
        Case 29, 30
            r = 57
        Case 80, 183
            r = 58
        Case 39, 112
            r = 61
        Case 38
            r = 62
        Case 4
            r = 67
        Case 5, 32, 33
            r = 70
        Case 3
            r = 76
        Case Else
            r = LastErrorCode
    End Select
    LastErrorToVBError = r
End Function

Public Function ShowOpen(ByVal hWnd As Long, ByVal sFilter As String, Optional ByVal sTitle As String = "", Optional ByVal sDefault As String = "") As String
ShowOpen = OpenFiles(hWnd, sTitle, sFilter, sDefault, OF_OPEN)(0)
End Function

Private Function OpenFiles(ByVal hWnd As Long, ByVal sTitle As String, ByVal sFilter As String, ByVal sDefault As String, ByVal Operation As Long, Optional lMaxFileNum As Long = MAX_PATH) As String()
'˵
'hWnd ָHWNDֵ
'sTitle ָԻı
'sFilter ָļĸʽ磺*.exe*.*ʹ÷ֺŸ
'uFlag ָǷѡļ1ԣֻѡһ
'lMaxFileNum ļȵֵһ255ļ࣬ʹ65535

Dim ofn As OPENFILENAME, uFlag As Long
Dim strFile As String, strFileTitle As String
Dim lRet As Long, strRet() As String, i As Long, FileCount As Long

If Operation = OF_OPEN Then
    uFlag = OFN_EXPLORER Or OFN_FILEMUSTEXIST
ElseIf Operation = OF_OPEN_MULTI Then
    uFlag = OFN_EXPLORER Or OFN_ALLOWMULTISELECT Or OFN_FILEMUSTEXIST
ElseIf Operation = OF_SAVE Then
    uFlag = OFN_EXPLORER 'Or OFN_OVERWRITEPROMPT
Else
    uFlag = 0
End If
sFilter = Replace(sFilter, "|", vbNullChar): sFilter = sFilter & vbNullChar & vbNullChar
If Len(sDefault) < lMaxFileNum Then
    strFile = sDefault & vbNullChar & Space$(lMaxFileNum - Len(sDefault) - 1)
Else
    strFile = sDefault & vbNullChar
End If
strFileTitle = Space$(lMaxFileNum)
With ofn
    .lStructSize = Len(ofn)
    .hwndOwner = hWnd
    .hInstance = App.hInstance
    .lpstrFile = StrPtr(strFile)
    .nMaxFile = lMaxFileNum
    .lpstrFileTitle = StrPtr(strFileTitle)
    .nMaxFileTitle = lMaxFileNum
    .lpstrTitle = StrPtr(sTitle)
    .lpstrFilter = StrPtr(sFilter)
    .lpstrDefExt = StrPtr("")
    .Flags = uFlag
End With

ReDim strRet(0) As String
If Operation = OF_OPEN Then
    lRet = GetOpenFileNameW(ofn)
    If lRet Then strRet(0) = Trunc(strFile) Else strRet(0) = ""
ElseIf Operation = OF_SAVE Then
    lRet = GetSaveFileNameW(ofn)
    If lRet Then strRet(0) = Trunc(strFile) Else strRet(0) = ""
ElseIf Operation = OF_OPEN_MULTI Then
    lRet = GetOpenFileNameW(ofn)
    If lRet Then
        Dim FileNames() As String
        FileNames() = Split(strFile, vbNullChar)
        If UBound(FileNames) < 3 Then
            strRet(0) = FileNames(0)
        Else
            If Right$(FileNames(0), 1) <> "\" Then FileNames(0) = FileNames(0) & "\"
            FileCount = UBound(FileNames) - 3
            ReDim strRet(0 To FileCount)
            For i = 0 To FileCount
                strRet(i) = FileNames(0) & FileNames(i + 1)
            Next
        End If
    Else
        strRet(0) = ""
    End If
End If
OpenFiles = strRet
End Function

Private Function Trunc(s As String) As String
Dim a As Long
a = InStr(s, vbNullChar)
If a > 0 Then
    Trunc = Left$(s, a - 1)
Else
    Trunc = s
End If
End Function

Function Utf8ToUnicode(ByRef st() As Byte) As String
Const CP_UTF8 = 65001
Dim L As Long, Start As Long, rt As String
L = MultiByteToWideChar(CP_UTF8, 0, VarPtr(st(0)), UBound(st) + 1, 0, 0)
rt = Space$(L)
MultiByteToWideChar CP_UTF8, 0, VarPtr(st(0)), UBound(st) + 1, StrPtr(rt), L
If Left$(rt, 1) = ChrW$(&HFEFF) Then rt = Mid$(rt, 2)
Utf8ToUnicode = rt
End Function

Private Function VBStrFromUnicodePtr(ByVal lpStr As Long) As String
Dim bStr() As Byte
Dim cChars As Long
On Error Resume Next
cChars = lstrlenW(lpStr) * 2
If cChars Then
    ReDim bStr(0 To cChars - 1) As Byte
    Call RtlMoveMemory(VarPtr(bStr(0)), lpStr, cChars)
End If
VBStrFromUnicodePtr = bStr
End Function

Public Sub FileCopy(Source As String, Destination As String, Optional Overwrite As Boolean = True)
    Dim ret As Long
    ret = CopyFileW(StrPtr(Source), StrPtr(Destination), Not Overwrite)
    If ret = 0 Then
        Err.Raise LastErrorToVBError(Err.LastDllError)
    End If
End Sub

Private Function SkipBlanks(ByVal Start As Long, ByRef s$) As Long
Dim a As String, i As Long, L As Long
L = Len(s$)
For i = Start To L
    a = Mid$(s$, i, 1)
    If a <> " " Then
        SkipBlanks = i
        Exit Function
    End If
Next i
SkipBlanks = 0
End Function

''' úⵥ
Private Function InStrChrOutQuote(ByVal Start As Long, ByRef s$, ByRef Char$) As Long
Dim q1 As Boolean, a As String, i As Long, L As Long
q1 = False
L = Len(s$)
For i = Start To L
    a = Mid$(s$, i, 1)
    If a = Char$ Then
        If q1 = False Then
            InStrChrOutQuote = i
            Exit Function
        End If
    Else
        If a = """" Then q1 = Not q1
    End If
Next i
InStrChrOutQuote = 0
End Function

Private Function CommandLineToArgv(ByRef lpCmdLine As String, Optional ByRef NumArgs As Long) As String()
Dim r$()
NumArgs = 0
If lpCmdLine <> "" Then
    Dim CmdLine$, p&, pe&
    CmdLine = Replace(lpCmdLine, ChrW$(9), " ")
    NumArgs = 0
    p = SkipBlanks(1, CmdLine)
    While p > 0
        pe = InStrChrOutQuote(p, CmdLine, " ")
        If pe = 0 Then pe = Len(CmdLine) + 1
        NumArgs = NumArgs + 1
        ReDim Preserve r(0 To NumArgs - 1) As String
        r(NumArgs - 1) = Replace(Mid$(CmdLine, p, pe - p), """", "")
        p = SkipBlanks(pe, CmdLine)
    Wend
End If
If lpCmdLine = "" Or NumArgs = 0 Then
    ReDim r(0 To 0) As String
    r(0) = FullExePath
    NumArgs = 1
End If
CommandLineToArgv = r
End Function

